#pragma once


#include <Color4.hpp>
#include <Colors.hpp>
#include <JUI/UDim.hpp>
#include <JUI/UDim2.hpp>

namespace JUI {

    namespace DefaultStyle {
        const Color4 BackgroundColor = {128, 128, 128};
        const Color4 BorderColor = {192, 192, 192};
        const float BorderLineWidth = 1.f;
        const UDim BasePadding = 0_px;

        namespace Button {
            const Color4 BaseBackgroundColor = Colors::White;
            const Color4 BaseBorderColor = Colors::Black;
            const Color4 HoverBackgroundColor = Colors::Blues::SkyBlue;
            const Color4 HoverBorderColor = Colors::Blues::DarkSlateBlue;
            const Color4 PressBackgroundColor = Colors::Blues::DarkSlateBlue;
            const Color4 PressBorderColor = Colors::Blues::SkyBlue;
            const Color4 DisableBackgroundColor = Colors::Gray;
            const Color4 DisableBorderColor = Colors::Gray;
        }

        namespace Image
        {
            //const
        }

        namespace Text {
            namespace H1 {

            }
            namespace H2 {

            }
        }

        namespace InputForm {
            const Color4 AutocompleteTextColor = Colors::Black;
        }

        namespace Collapsible {
            const UDim HeaderHeight = 16_px;
        }

        namespace Checkbox {
            const Color4 CheckmarkColor = Colors::Red;

        }
        namespace Window {
            const UDim2 DefaultSize = {200_px, 200_px};
            const Vector2 DefaultMinimumSize = {200, 200};
            const int TitlebarHeight = 20;
            const Color4 OutlineColor = {92, 92, 192};
            const Color4 UnfocusedOutlineColor = Colors::Gray;
            const Color4 ViewportBackgroundColor = Colors::DarkGray;
            const int OutlineWidth = 2;

        }

    }

    namespace ExperimentalStyle {

    }

    namespace Style = DefaultStyle;
}