/// Josh's User Interface Library
/// A C++20 Library for creating, styling, and rendering of a UI/UX widgets.
/// Developed and Maintained by Josh O'Leary @ Redacted Software.
/// Special Thanks to William Tomasine II and Maxine Hayes.
/// (c) 2024 Redacted Software
/// This work is dedicated to the public domain.

/// @file ImageRect.hpp
/// @desc A widget that contains and renders an image provided by JGL, within a rectangular frame.
/// @edit 2024-08-05

#pragma once

#include <JUI/Widgets/Rect.hpp>
#include <JUI/Base/ImageBase.hpp>

namespace JUI {
    class ImageRect: public Rect, public ImageBase {
    public:
        ImageRect();
        explicit ImageRect(Widget* parent);
        void Update(float delta) override;

        void Draw() override;

        bool FitImageToBounds() const { return fit_image_to_bounds;}
        void FitImageToBounds(bool value) { fit_image_to_bounds = value;}
    protected:
        bool fit_image_to_bounds;
    };
}