/// Josh's User Interface Library
/// A C++20 Library for creating, styling, and rendering of a UI/UX widgets.
/// Developed and Maintained by Josh O'Leary @ Redacted Software.
/// Special Thanks to William Tomasine II and Maxine Hayes.
/// (c) 2024 Redacted Software
/// This work is dedicated to the public domain.

/// @file TextButton.hpp
/// @desc Button class with text. @see Button, Text
/// @edit 2024-10-31

#pragma once

#include <JUI/Widgets/Button.hpp>

namespace JUI
{
    /// Text-displaying button widget.
    class TextButton : public Button, public TextBase {
    public:
        TextButton();
        explicit TextButton(Widget* parent);
        ~TextButton() override {};
        void Update(float delta) override;
        void Draw() override;
    };
}