#pragma once


#include <JUI/Widgets/TextRect.hpp>
#include "ReWindow/InputService.h"

namespace JUI
{
    class Tooltip : public TextRect
    {
    public:
        Tooltip() : TextRect() {
            Name("Tooltip");
        }
        explicit Tooltip(Widget* parent) : Tooltip() {
            attachment = parent;
            this->Parent(parent->GetFamilyTreeRoot());
            this->AutoFitSizeToText(true);
            this->ZIndex(10);
            this->Visible(false);
            this->Size({100_px, 20_px});
        }

        void Update(float delta) override;

        ~Tooltip() override {};

        Widget* attachment = nullptr;

        float PopupDelay() const { return 0;}

    protected:
        float popup_delay = 0.f;
    };
}