#include <JUI/UDim.hpp>

JUI::UDim JUI::UDimLiterals::operator ""_scale(long double sc) {
    return {0, static_cast<float>(sc)};
}

JUI::UDim JUI::UDimLiterals::operator ""_percent(unsigned long long pc) {
    return {0, pc/100.f};
}

JUI::UDim JUI::UDimLiterals::operator ""_pixels(unsigned long long px) {
    return {static_cast<int>(px), 0.f};
}

JUI::UDim JUI::UDimLiterals::operator ""_px(unsigned long long px) {
    return {static_cast<int>(px), 0.f};
}

JUI::UDim JUI::UDim::FromPixels(int pixels) { return {pixels, 0.f}; }

JUI::UDim JUI::UDim::FromScale(float scale) { return {0, scale}; }

JUI::UDim JUI::UDim::operator+(const UDim &rhs) const {
    return {Pixels + rhs.Pixels, Scale + rhs.Scale};
}

JUI::UDim JUI::UDim::operator-(const UDim &rhs) const {
    return {Pixels - rhs.Pixels, Scale - rhs.Scale};
}

JUI::UDim JUI::UDim::operator*(float rhs) const {
    return {static_cast<int>(Pixels * rhs), Scale*rhs};
}

JUI::UDim JUI::UDim::operator/(float rhs) const {
    return {static_cast<int>(Pixels / rhs), Scale/rhs};
}

JUI::UDim JUI::UDim::Lerp(const JUI::UDim &goal, float t) {
    float scale = J3ML::Math::Lerp(Scale, goal.Scale, t);
    float pixels = J3ML::Math::Lerp(Pixels, goal.Pixels, t);

    return UDim(pixels, scale);
}

bool JUI::UDim::Equals(const JUI::UDim &rhs, float epsilon) {
    return J3ML::Math::Equal((float)Pixels, rhs.Pixels, epsilon)
           && J3ML::Math::Equal(Scale, rhs.Scale, epsilon);
}

