#include <JUI/Widgets/Checkbox.hpp>


namespace JUI {

    Checkbox::Checkbox() : Button(), CheckboxBase() {
        Padding(2_px);
    }

    Checkbox::Checkbox(Widget *parent) : Checkbox() {
        this->Parent(parent);
    }

    void Checkbox::Update(float delta) {
        Button::Update(delta);
    }

    void Checkbox::OnRelease(const Vector2 &mouse_pos, const MouseButton &bnt, bool still_hovering) {
        Button::OnRelease(mouse_pos, bnt, still_hovering);
        checked = !checked;
    }

    void Checkbox::InnerDraw() {
        Rect::InnerDraw();

        // TODO: Renders too large with BorderMode::Inset
        if (checked) {
            Vector2 pos_pad = ComputeElementPadding(GetAbsoluteSize(), {PaddingLeft(), PaddingTop()});
            Vector2 size_pad = ComputeElementPadding(GetAbsoluteSize(), {PaddingLeft()+PaddingRight(), PaddingTop()+PaddingBottom()});
            Vector2 padded_pos = GetAbsolutePosition() + pos_pad;
            Vector2 padded_size = GetAbsoluteSize() - size_pad;
            RectBase::Draw(check_color, border_color, padded_pos, padded_size);
        }
    }
}