#include <JUI/Widgets/LabeledSlider.hpp>

JUI::LabeledSlider::LabeledSlider(): Slider(), TextBase() {

}

JUI::LabeledSlider::LabeledSlider(Widget *parent): LabeledSlider() {
    this->Parent(parent);
}

void JUI::LabeledSlider::Draw() {
    Slider::Draw();

    auto abs_pos = this->GetAbsolutePosition();
    auto abs_size = this->GetAbsoluteSize();

    auto pos_pad = GetAbsolutePaddingTopLeft();
    auto size_pad = GetAbsolutePaddingBottomRight();

    TextBase::Draw(abs_pos + pos_pad, abs_size - size_pad);
}

void JUI::LabeledSlider::Update(float elapsed) {
    Slider::Update(elapsed);
    TextBase::Update(elapsed);
}
