#include "JUI/Widgets/TextRect.hpp"

namespace JUI {
    TextRect::TextRect() : Rect(), TextBase() {
        Name("TextRect");
    }
    TextRect::TextRect(Widget* parent) : TextRect() {
        this->Parent(parent);
    }

    void TextRect::Update(float delta) {

        if (fit_size_to_text)
        {

            Vector2 abs_pos = this->GetAbsolutePosition();
            Vector2 abs_size = this->GetAbsoluteSize();


            // TODO: Apply this everywhere..
            Vector2 pad_shifts_pos_by = {
                    pad_left.Pixels + (pad_left.Scale * abs_size.x),
                    pad_top.Pixels + (pad_left.Scale * abs_size.y)
            };
            Vector2 pad_shrinks_size_by = {
                    pad_right.Pixels + (pad_left.Scale * abs_size.x),
                    pad_bottom.Pixels + (pad_right.Scale * abs_size.y)
            };

            Vector2 size = this->font.MeasureString(this->content, this->text_size);
            //size += pad_shrinks_size_by*2.f;

            //if (abs_size.x < size.x)
                this->size.X.Pixels = size.x;
            //if (abs_size.y < size.y)
                this->size.Y.Pixels = size.y;

        }

        Rect::Update(delta);
        TextBase::Update(delta);
    }


    void TextRect::InnerDraw()
    {
        Rect::InnerDraw();
        Vector2 abs_pos = this->GetAbsolutePosition();
        Vector2 abs_size = this->GetAbsoluteSize();

        Vector2 pos_pad = GetAbsolutePaddingTopLeft();
        Vector2 size_pad = GetAbsolutePaddingBottomRight();

        TextBase::Draw(abs_pos + pos_pad, abs_size - size_pad);
    }

    void TextRect::Draw() {
        Rect::Draw();
    }


}


